 -- S.MG, 2019


package body Procs is

  procedure A is
    N    : Unsigned_32;
  begin
    X := X + 1;

    if X <= Max then
      N := MT.Gen_U32;
      if N mod 3 = 0 then
        B; C;
      elsif N mod 3 = 1 then
        B;
      else
        C;
      end if;
    end if;
    exception
      when E1 => 
        Y := Y + 10;
      when E2 => 
        Y := Y + 100;
      when E3 => 
        Y := Y + 1000;
  end A;

  procedure B is
    N    : Unsigned_32;
  begin
    X := X + 1;

    if X <= Max then
      N := MT.Gen_U32;
      if N mod 3 = 0 then
        A; C;
      elsif N mod 3 = 1 then
        A;
      else
        C;
      end if;
    end if;
    exception
      when E1 => 
        Y := Y + 10;
      when E2 => 
        Y := Y + 100;
      when E3 => 
        Y := Y + 1000;
  end B;

  procedure C is
    N    : Unsigned_32;
  begin
    X := X + 1;

    if X <= Max then
      N := MT.Gen_U32;
      if N mod 3 = 0 then
        A; B;
      elsif N mod 3 = 1 then
        A;
      else
        B;
      end if;
    end if;
    exception
      when E1 => 
        Y := Y + 10;
      when E2 => 
        Y := Y + 100;
      when E3 => 
        Y := Y + 1000;
  end C;

begin
  -- seed the MT prng
  Seeds(0) := MT.U32(16#111#);  
  Seeds(1) := MT.U32(16#222#);  
  Seeds(2) := MT.U32(16#333#);  
  Seeds(3) := MT.U32(16#444#);  
  MT.Init_Genrand(Seeds);
  
end Procs;
