 -- S.MG, 2019
 -- Testing package for pseudo-random procedure calls

with Interfaces; use Interfaces;
with MT;

package Procs is
  -- to init the MT PRNG properly
  pragma Elaborate_Body; 

  E1, E2, E3: exception;
  Y     : Unsigned_64 := 0;

  Max: constant Unsigned_64 := 16777216;
  X     : Unsigned_64 := 0;

  procedure A;
  procedure B;
  procedure C;

private
  Seeds : MT.Init_Array_Type;

end Procs;
